/**
 *  @author     TTF006
 *  @version    $Id: $
 *  @desc       This module provides TCI for VxLTE.
 *  @see        
 */
package com.iskratel.ttcn.tci.codec.SIPCodec;

import java.io.ByteArrayOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.ByteArrayInputStream;
import java.io.IOException;

import org.apache.log4j.Logger;
import org.etsi.ttcn.tci.BooleanValue;
import org.etsi.ttcn.tci.CharstringValue;
import org.etsi.ttcn.tci.EnumeratedValue;
import org.etsi.ttcn.tci.IntegerValue;
import org.etsi.ttcn.tci.OctetstringValue;
import org.etsi.ttcn.tci.RecordOfValue;
import org.etsi.ttcn.tci.RecordValue;
import org.etsi.ttcn.tci.TciCDProvided;
 import org.etsi.ttcn.tci.TciCDRequired;
 import org.etsi.ttcn.tci.TciTMProvided;
import org.etsi.ttcn.tci.TciTypeClass;
import org.etsi.ttcn.tci.Type;
import org.etsi.ttcn.tci.UnionValue;
import org.etsi.ttcn.tci.Value;
import org.etsi.ttcn.tri.TriMessage;

import com.testingtech.ttcn.extension.CodecProvider;
import com.testingtech.ttcn.logging.RTLoggingConstants;
import com.testingtech.ttcn.tri.AbstractCodecPlugin;

import com.testingtech.ttcn.logging.TciTLProvidedV321TT;
import com.testingtech.ttcn.tci.codec.base.AbstractBaseCodec;

import de.tu_berlin.cs.uebb.muttcn.runtime.RB;
import de.tu_berlin.cs.uebb.ttcn.runtime.BitString;
import de.tu_berlin.cs.uebb.ttcn.runtime.ForeignMessage;
  
public class SIPCodec extends AbstractBaseCodec implements TciCDProvided {

	protected TciTLProvidedV321TT logging;
	protected TciCDRequired typeServer;
	protected TciTMProvided management;
	
	private Logger log;
	
	public SIPCodec(RB rb) {
		super(rb);
		typeServer = RB.getTciCDRequired();
		management = RB.getTciTMProvided();
	}

	public synchronized void setLogger(Logger logger) {
		this.log = logger;
	}
	
	@Override
	public Value decode(TriMessage message, Type decodingHypothesis) {
		// Get the received byte array 
		encodedMsg = message.getEncodedMessage();
        // Set the bitpos to 0 (this is needed to know the actual bit position from the byte array)
	    bitpos = 0;
	    // The the encoded message is null, nothing can be done, so return null 
	    if(encodedMsg.length == 0) return null;
        
	    return super.decode(message,decodingHypothesis);
	}

	@Override
	public TriMessage encode(Value value) {
		// The template is given to the AbstractBaseCodec which handles the basic encoding
        TriMessage encodedMessage = super.encode(value);
        return encodedMessage;
	}    
	
}
	

