/**
 *  @author     TTF006
 *  @version    $Id: $
 *  @desc       This module provides connection to control devices for VxLTE.
 *  @see        
 */
package com.iskratel.ttcn.tri;

import org.etsi.ttcn.tri.TriAddress;
import org.etsi.ttcn.tri.TriCommunicationTE;
import org.etsi.ttcn.tri.TriComponentId;
import org.etsi.ttcn.tri.TriMessage;
import org.etsi.ttcn.tri.TriPortId;
import org.etsi.ttcn.tri.TriStatus;

import com.testingtech.ttcn.tci.TciModuleParameterIdImpl;
import com.testingtech.ttcn.tri.TriAddressImpl;
import com.testingtech.ttcn.tri.TriMessageImpl;
import com.testingtech.ttcn.tri.TriStatusImpl;

public class EaPortConnection /*extends *** */ implements LocalAdapterBase {
		
	TriCommunicationTE cte = null;
	TriPortId comPortId = null;
	TriPortId tsiPortId = null;

	public EaPortConnection(TriCommunicationTE cte) {
		this.cte = cte;
	}

	public /*synchronized*/ TriStatus triMap(TriPortId comPortId, TriPortId tsiPortId) {
		
			boolean result=true;

			this.comPortId = comPortId;
			this.tsiPortId = tsiPortId;

			return (result == true) ? new TriStatusImpl(TriStatus.TRI_OK) : new TriStatusImpl(TriStatus.TRI_ERROR);
	}

    public /*synchronized*/TriStatus triSend(TriComponentId componentId, TriPortId tsiPortId,TriAddress triAddress,	TriMessage triMessage) {
		
   		    byte[] message = triMessage.getEncodedMessage();
   		    
   		    byte[] messagerecv = {0x00}; //Assume status OK Response
   		    TriMessage triMessagerecv =TriMessageImpl.valueOf(messagerecv);//.setEncodedMessage(message);
 		    TriAddress triAddressrecv = new TriAddressImpl(new byte[] {});
 		    		    
 		    synchronized(cte) {
 			    cte.triEnqueueMsg(tsiPortId, triAddress, comPortId.getComponent(), triMessage); 			
 		    }
   		    
   		    return (message == null) ? new TriStatusImpl(TriStatus.TRI_ERROR) : new TriStatusImpl(TriStatus.TRI_OK);
	}

	public /*synchronized*/ TriStatus triUnmap() {
		return new TriStatusImpl(TriStatus.TRI_OK);
	}
	
	public  /*synchronized*/ TriStatus triUnmap(TriPortId comPortId, TriPortId tsiPortId) {
		return triUnmap();
	}
}
